<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html">sdkInterfaces</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html">AuthDelegateInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_auth_delegate_interface_8h_source.html">AuthDelegateInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1acl_1_1test_1_1_mock_auth_delegate.html" title="alexaClientSDK::acl\l::test::MockAuthDelegate" alt="" coords="337,5,507,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html" title="alexaClientSDK::authorization\l::cblAuthDelegate::CBLAuthDelegate" alt="" coords="301,68,542,107"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1capabilities_delegate_1_1test_1_1_test_auth_delegate.html" title="alexaClientSDK::capabilities\lDelegate::test::TestAuthDelegate" alt="" coords="314,131,530,169"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae2256b1de42b60b2a08500f45c6f3669"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#ae2256b1de42b60b2a08500f45c6f3669">~AuthDelegateInterface</a> ()=default</td></tr>
<tr class="separator:ae2256b1de42b60b2a08500f45c6f3669"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4828a1a064ec6c1c1d9c2fefad5d5d0d"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a4828a1a064ec6c1c1d9c2fefad5d5d0d">addAuthObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt; observer)=0</td></tr>
<tr class="separator:a4828a1a064ec6c1c1d9c2fefad5d5d0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acba7bf24a550d8009a0d9adbb72955b0"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#acba7bf24a550d8009a0d9adbb72955b0">removeAuthObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt; observer)=0</td></tr>
<tr class="separator:acba7bf24a550d8009a0d9adbb72955b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fe1b7ac461f206358d5c7e7e82121f5"><td class="memItemLeft" align="right" valign="top">virtual std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a1fe1b7ac461f206358d5c7e7e82121f5">getAuthToken</a> ()=0</td></tr>
<tr class="separator:a1fe1b7ac461f206358d5c7e7e82121f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a593db990b9dffa41a6d101be30c1ed70"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a593db990b9dffa41a6d101be30c1ed70">onAuthFailure</a> (const std::string &amp;token)=0</td></tr>
<tr class="separator:a593db990b9dffa41a6d101be30c1ed70"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">The <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html">AuthDelegateInterface</a> is used to provide clients with valid LWA authorization tokens. </p><dl class="section see"><dt>See also</dt><dd><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/content/avs-api-overview#authorization">https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/content/avs-api-overview#authorization</a> Given an <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html">AuthDelegateInterface</a></code> pointer, the client is expected to call <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a1fe1b7ac461f206358d5c7e7e82121f5">getAuthToken()</a></code> immediately before making AVS requests. The returned value is passed in the HTTP/2 header of requests sent to AVS. These <a class="el" href="namespacealexa_client_s_d_k_1_1authorization.html">authorization</a> tokens may expire, so AuthDelegates also track the state of <a class="el" href="namespacealexa_client_s_d_k_1_1authorization.html">authorization</a> (essentially, whether an immediate call to <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_delegate_interface.html#a1fe1b7ac461f206358d5c7e7e82121f5">getAuthToken()</a></code> will return a token that is expected to be viable). The client may elect to receive callbacks when this state changes by calling <code>setAuthObserver()</code>. This allows the client to avoid sending requests tha are doomed to fail because the <a class="el" href="namespacealexa_client_s_d_k_1_1authorization.html">authorization</a> token has already expired. This also allows the client to know when <a class="el" href="namespacealexa_client_s_d_k_1_1authorization.html">authorization</a> has been restored. </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ae2256b1de42b60b2a08500f45c6f3669"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2256b1de42b60b2a08500f45c6f3669">&#9670;&nbsp;</a></span>~AuthDelegateInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface::~AuthDelegateInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Virtual destructor to assure proper cleanup of derived types. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a4828a1a064ec6c1c1d9c2fefad5d5d0d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4828a1a064ec6c1c1d9c2fefad5d5d0d">&#9670;&nbsp;</a></span>addAuthObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface::addAuthObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Specify an object to observe changes to the authorization state of this AuthDelegate. During the call to this setter the observers onAuthStateChange() method will be called back with the current authorization state.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The object to observe this authorization state of this AuthDelegate. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ae3b4c2dbdbc2bbb4ce098faa4f92fdc5">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate</a>.</p>

</div>
</div>
<a id="a1fe1b7ac461f206358d5c7e7e82121f5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1fe1b7ac461f206358d5c7e7e82121f5">&#9670;&nbsp;</a></span>getAuthToken()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::string alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface::getAuthToken </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get the current LWA authorization token.</p>
<dl class="section return"><dt>Returns</dt><dd>The current authorization token. The returned value will be empty if an authorization token has yet to be acquired or if the most recently acquired token has expired. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a6090364bb64d10192a562c93fb0a823d">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate</a>, <a class="el" href="classalexa_client_s_d_k_1_1capabilities_delegate_1_1test_1_1_test_auth_delegate.html#afc7f15bd4c1e1501acc4c0b1ba7e2726">alexaClientSDK::capabilitiesDelegate::test::TestAuthDelegate</a>, and <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1test_1_1_mock_auth_delegate.html#a233c51c1914a316381fe734ebcecb858">alexaClientSDK::acl::test::MockAuthDelegate</a>.</p>

</div>
</div>
<a id="a593db990b9dffa41a6d101be30c1ed70"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a593db990b9dffa41a6d101be30c1ed70">&#9670;&nbsp;</a></span>onAuthFailure()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface::onAuthFailure </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>token</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Receive notification that an operation using the specified auth token experienced an authorization failure.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">token</td><td>The token used to authorize the forbidden operation. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#a633e5f9dd987fac530edf5fbb443ec3f">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capabilities_delegate_1_1test_1_1_test_auth_delegate.html#a3d77fc05f5a75be6bad2d35b05d61698">alexaClientSDK::capabilitiesDelegate::test::TestAuthDelegate</a>.</p>

</div>
</div>
<a id="acba7bf24a550d8009a0d9adbb72955b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acba7bf24a550d8009a0d9adbb72955b0">&#9670;&nbsp;</a></span>removeAuthObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::AuthDelegateInterface::removeAuthObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_auth_observer_interface.html">avsCommon::sdkInterfaces::AuthObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Remove an observer</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to remove. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1authorization_1_1cbl_auth_delegate_1_1_c_b_l_auth_delegate.html#ad9c4e36ecd1310564e2bcb0950e52b52">alexaClientSDK::authorization::cblAuthDelegate::CBLAuthDelegate</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/<a class="el" href="_auth_delegate_interface_8h_source.html">AuthDelegateInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
